﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;

namespace MyDemoService
{
    public partial class DemoService : ServiceBase
    {
        public DemoService()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            try
            {
                EventLog startLog = new EventLog("Demo Application");
                startLog.Source = "Demo Service";
                startLog.WriteEntry("Demo Starting ", EventLogEntryType.Information, 1000);

                startLog.Dispose();
            }
            catch (Exception ex)
            {
                //Catch the exception to avoid unhandled errors and stop the service.
                this.Stop();
            }
        }

        protected override void OnStop()
        {
            try
            {
                EventLog stopLog = new EventLog("Demo Application");
                stopLog.Source = "Demo Service";
                stopLog.WriteEntry("Demo Stopping ", EventLogEntryType.Information, 1001);
                stopLog.Dispose();
            }
            catch (Exception ex)
            {
                //Catch the exception to avoid unhandled errors and write the output to the debug window.
                Debug.WriteLine("Error stopping service: " + ex.ToString());
            }
        }

        protected override void OnPause()
        {
            try
            {
                EventLog stopLog = new EventLog("Demo Application");
                stopLog.Source = "Demo Service";
                stopLog.WriteEntry("Demo Pausing ", EventLogEntryType.Information, 1002);
                stopLog.Dispose();
            }
            catch (Exception ex)
            {
                //Catch the exception to avoid unhandled errors and write the output to the debug window.
                Debug.WriteLine("Error Pausing service: " + ex.ToString());
                this.Stop();
            }
        }

        protected override void OnContinue()
        {
            try
            {
                EventLog continueLog = new EventLog("Demo Application");
                continueLog.Source = "Demo Service";
                continueLog.WriteEntry("Demo Continuing ", EventLogEntryType.Information, 1003);
                continueLog.Dispose();
            }
            catch (Exception ex)
            {
                //Catch the exception to avoid unhandled errors and write the output to the debug window.
                Debug.WriteLine("Error resuming service: " + ex.ToString());
                this.Stop();
            }
        }

    }
}
